<?php if(!defined('PLX_ROOT')) exit;
/**
 * Plugin SunEditor for Pluxml
 *
 * @package  SunEditor
 * @version  1.3.2
 * @date  21.02.2021
 * @author   Thomas Ingles, sudwebdesign.free.fr
 **/
class SunEditor extends plxPlugin {
 const DIST = '/SunEditor-2.36.4';# editor folder
 const CDIST = '5.59.3';# cdn.jsdelivr.net/npm/codemirror@CDIST
 const KDIST = '0.12.0';# cdn.jsdelivr.net/npm/katex@KDIST
 public $lang;
 public function __construct($default_lang){
  parent::__construct($default_lang);
  if(defined('PLX_ADMIN')) {//Déclaration des hooks pour la zone d'administration
   if(strstr($_SERVER['PHP_SELF'],'article.php') || strstr($_SERVER['QUERY_STRING'],'plxMyShop&prod')){//edit art ou prod slmnt ::: strstr($_SERVER['PHP_SELF'],'statique.php') ||
    $this->lang = ( isset($_SESSION['admin_lang'])?$_SESSION['admin_lang'] : (isset($_SESSION['lang'])?$_SESSION['lang']:$default_lang) );//$_SESSION['admin_lang']:plx>=5.6
    $this->addHook('plxAdminEditArticleXml', 'plxAdminEditArticleXml');#clean empty chapo...
    $this->addHook('plxAdminEditArticle', 'plxAdminEditArticle');#abs2rel
    $this->addHook('AdminArticleTop', 'AdminArticleTop');#rel2abs
#   $this->addHook('AdminArticleContent', 'AdminArticleContent');#Uploaded image file list
    $this->addHook('AdminTopEndHead', 'AdminTopEndHead');#editor
    $this->addHook('AdminFootEndBody', 'AdminFootEndBody');#editor
   }
   if(strstr($_SERVER['PHP_SELF'],'medias.php'))//si medias.php
    $this->addHook('AdminMediasFoot', 'AdminMediasFoot');#editor medias manager js onclic return
  }else/* if(strstr($_SERVER['QUERY_STRING'],'article') || strstr($_SERVER['QUERY_STRING'],'preview'))*/{
   $this->addHook('ThemeEndHead', 'ThemeEndHead');
  }
  #var_dump($_SERVER['QUERY_STRING'], strstr($_SERVER['QUERY_STRING'],'article'), strstr($_SERVER['QUERY_STRING'],'preview'));exit;
 }
 public function ThemeEndHead(){//if plxMotor->mode == article Todo...
  $link = '<link href="'.PLX_PLUGINS.__CLASS__.self::DIST.'/src/assets/css/suneditor-contents.css" rel="stylesheet" type="text/css">';
  echo '<?php ';?>
  $aModes = array('home', 'categorie', 'tag', 'article');
  if(in_array($plxMotor->mode, $aModes))
   echo '<?= $link ?>';
?><?php
 }
 public function plxAdminEditArticleXml(){#Méthode qui supprime les <p><br></p> lorsque les textareas sont laissé tel quel a l'enregistrement : Fix chapô tjrs ouvert après enregistrement (et vide)
  echo '<?php '; ?>
  $xml = str_replace(array('<![CDATA[<p><br></p>]]>'),array('<![CDATA[]]>'),$xml); ?><?php
 }
 public function plxAdminEditArticle(){#Méthode qui convertit les liens absolus en liens relatifs pour les medias, images et les documents?
  echo '<?php '; ?>
 $d = '="';
 $s = "='";
 if(isset($this->aConf['medias'])){// plx.5.4+
  $c = array($d.$this->racine.$this->aConf['medias'],$s.$this->racine.$this->aConf['medias']);
  $r = array($d.$this->aConf['medias'],$s.$this->aConf['medias']);
 }else{
  $c = array($d.$this->racine.$this->aConf['images'],$s.$this->racine.$this->aConf['images'],$d.$this->racine.$this->aConf['documents'],$s.$this->racine.$this->aConf['documents']);
  $r = array($d.$this->aConf['images'],$s.$this->aConf['images'],$d.$this->aConf['documents'],$s.$this->aConf['documents']);
 }
 $content['chapo'] = str_replace($c,$r,$content['chapo']);
 $content['content'] = str_replace($c,$r,$content['content']);
?><?php
  }
 public function AdminArticleTop(){#Méthode qui convertit les liens relatifs en liens absolus pour l'affichage dans wym des medias, images et documents?
  echo '<?php '; ?>
 $d = '="';
 $s = "='";
 if(isset($plxAdmin->aConf['medias'])){// plx.5.4+
  $c = array($d.$plxAdmin->aConf['medias'],$s.$plxAdmin->aConf['medias']);
  $r = array($d.$plxAdmin->racine.$plxAdmin->aConf['medias'],$s.$plxAdmin->racine.$plxAdmin->aConf['medias']);
 }else{
  $c = array($d.$plxAdmin->aConf['images'],$s.$plxAdmin->aConf['images'],$d.$plxAdmin->aConf['documents'],$s.$plxAdmin->aConf['documents']);
  $r = array($d.$plxAdmin->racine.$plxAdmin->aConf['images'],$s.$plxAdmin->racine.$plxAdmin->aConf['images'],$d.$plxAdmin->racine.$plxAdmin->aConf['documents'],$s.$plxAdmin->racine.$plxAdmin->aConf['documents']);
 }
 $chapo = str_replace($c,$r,$chapo);
 $content = str_replace($c,$r,$content);
?><?php
 }
 public function AdminTopEndHead(){#Insertion des dépendances js et css
  if(!file_exists(PLX_ROOT.'/core/lib/mediasManager.js'))#mediaManager
   echo '<script type="text/javascript" src="<?= PLX_PLUGINS.__CLASS__ ?>/mediasManager.js"></script>'.PHP_EOL;//FROM PLX 5.5
?>
<link href="<?= PLX_PLUGINS.__CLASS__.self::DIST ?>/dist/css/suneditor.min.css" rel="stylesheet" type="text/css">
<style>
.sun-editor button, .sun-editor input[type="button"], .sun-editor input[type="reset"], .sun-editor input[type="submit"] {color: #222;}
.sun-editor .se-toolbar{z-index:2!important;outline:none!important;border-bottom:1px solid #dadada;}
.sun-editor .se-btn.se-btn-select{width: 60px;}
.sun-editor .se-btn {margin:0px!important;width:30px;height:30px;}
.sun-editor .se-toolbar [class*="icon-"]::before {line-height: 2.0 !important;}/* fix border bottom icons */
.section .action-bar, .section .in-action-bar {z-index: 4!important;}
.sun-editor .se-controller {z-index: 1!important;}
.plxtoolbar{display:none;}
</style>
    <!-- codeMirror -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/codemirror@<?=self::CDIST?>/lib/codemirror.min.css">
    <!-- KaTeX -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/katex@<?=self::KDIST?>/dist/katex.min.css">
<?php
 }
 public function AdminArticleContent(){#return;#Insertion de la liste des image téléversées par l'éditeur #inutilisé #PLM
  #Uploaded image file list FileName, Size, Remove / del
  foreach(explode(' ','chapo content') as $list){
?>
 <h4 class="sub-title">Liste des image téléversées de <?= $list ?></h4>
 <div style="clear:both" class="scrollable-table">
  <table class"full-width">
   <colgroup><col width="70%"></colgroup>
   <thead>
    <tr>
     <th>Nom</th>
     <th>Taille</th>
     <th>Éffacer</th>
    </tr>
   </thead>
   <tbody id="imageTable<?= $list ?>"></tbody>
  </table>
 </div>
<?php
  }
 }
 public function AdminFootEndBody(){#Insertion du script de gestion de l'éditeur
  $plxAdminbar = (isset($_SESSION['plxAdminBar']) AND ($_SESSION['plxAdminBar'] == 'admin' OR $_SESSION['plxAdminBar'] == 'all') );
  if($plxAdminbar){
   $aop = array(46,150);//137 = 105 + 32 for pluxml 5.6
  }else{
   $aop = array(35,120);
  }
// script de gestion dans PluXml suneditor.src.plx.js
?>
<script src="<?= PLX_PLUGINS.__CLASS__.self::DIST ?>/dist/suneditor.min.js"></script>
<script src="<?= PLX_PLUGINS.__CLASS__.self::DIST ?>/src/lang/<?= $this->lang ?>.js"></script>
<!-- codeMirror -->
<script src="https://cdn.jsdelivr.net/npm/codemirror@<?=self::CDIST?>/lib/codemirror.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/codemirror@<?=self::CDIST?>/mode/htmlmixed/htmlmixed.js"></script>
<script src="https://cdn.jsdelivr.net/npm/codemirror@<?=self::CDIST?>/mode/xml/xml.js"></script>
<script src="https://cdn.jsdelivr.net/npm/codemirror@<?=self::CDIST?>/mode/css/css.js"></script>
<!-- KaTeX -->
<script src="https://cdn.jsdelivr.net/npm/katex@<?=self::KDIST?>/dist/katex.min.js"></script>
<script type="text/javascript">
 if(typeof SUNEDITOR != 'undefined') {
  var plxHHeight = 0;
  var plxHead = document.querySelector(".header.sml-text-center.med-text-right");
//plxHead.parentNode.parentNode.parentNode IS BODY
  var plxSctn = document.querySelector("section.section.col.sml-12");// .med-9.med-offset-3.lrg-10.lrg-offset-2
  function plxHeadTest() {
   var mcslc = (plxHead.parentNode.style.display !== 'none');
   return mcslc;// ? plxHead.offsetHeight : 0;
  }

  function plxHeadHeight() {
   try{xscreen(mql);}catch(e){}
   mdscreen(mdl);
   if(!plxHeadTest()) plxHHeight = 0;//return document.body.style.marginTop;
   return plxHHeight;// + aop;// + plxSctn.style.marginTop + plxSctn.style.marginBottom);
  }
  var aop = <?= $aop[0] ?>;//top is reseved keyword ?

  function mdscreen(e) {
    plxHHeight = 0;
    if(!aop) return;
    aop = <?= $aop[1] ?>;
    if (e.matches){//the viewport is 767 pixels wide or less
      aop = <?= $aop[0] ?>;
      plxHHeight = plxHeadTest() ? plxHead.offsetHeight : 0;
//       console.warn('mdscreen match');//
    }
//     console.warn('mdscreen',aop, plxHHeight);//
//     console.warn('mdscreen', document.body.offsetTop, document.body.style.marginTop, aop, plxHHeight, plxHead.offsetHeight);//
  }
  function screenTest() {//console.warn('screentest : ' + aop);
    return aop;
  }
  var mdl = window.matchMedia('(max-width: 767px)');
  mdscreen(mdl);// Call listener function at run time
  mdl.addListener(mdscreen);// Attach listener function on state changes

  var plxLng = {'chapo':"Rédiger un texte ici donne lieu aux «Lire la suite»",'content':"Rédiger le texte principal ou la suite du chapô de l'article ici"};
  var fromEditor = false;//Fix window.opener image d'accroche
  var is_modified = editorid = 0;
  editor = new Array();
  textareas = document.getElementsByTagName("textarea");
  let CMOK = (typeof CodeMirror == 'undefined'? !1: CodeMirror);
  let KXOK = (typeof katex == 'undefined'? !1: katex);
  let mediasBtn = ['link', 'image', 'video'];
  if(KXOK) mediasBtn.push('math');
  for(var i=0;i<textareas.length;i++) {
   var n = textareas[i].name;
   //~ if(n=='content' || n=='chapo') {
   if(n.search(/content|chapo/) > -1) {// For plxMyMultilingue _fr _en_ ru _##
    //editor[i] enabled() : disabled() : destroy() ... toggle
    editor[i] = SUNEDITOR.create(textareas[i].id, {
     imageUploadUrl: '<?= PLX_PLUGINS.__CLASS__ ?>/ajax_upload.php?type=Images&plx=<?= @PLX_VERSION ?>',
     imageUploadHeader: {"Access-Control-Allow-Origin": "*"},//>=2.15.3
//     imageUrlInput: true
//     imageFileInput: true,

     placeholder: plxLng[n] + '...',
     lang: SUNEDITOR_LANG['<?= $this->lang ?>'],
     mode: 'classic',//balloon inline
     display: 'block',
     stickyToolbar: 0,//0 ou +, -1 pour désactiver le mode sticky
     width: '100%',//
     height: 'auto',
     popupDisplay: 'full',
     charCounter: true,
//   maxCharCount: 700,
     charCounterLabel: '🔤 :',
     codeMirror: CMOK,
     katex: KXOK,
     buttonList: [
      ['save', 'fullScreen'],
      ['undo', 'redo'],
      ['removeFormat'],
      ['fontSize', 'formatBlock'],
//      ['font'],
      ['fontColor', 'hiliteColor', 'textStyle'],
      ['outdent', 'indent'],
      ['align'],
      ['bold', 'italic', 'underline', 'strike'],
      ['subscript', 'superscript'],
      ['horizontalRule'],
      ['list', 'table'],
      mediasBtn,
      [//Media manager natif de PluXml : suneditor.com/sample/html/customPlugins.html
       {
        name: 'file-manager',// plugin's name attribute to be recognized by the toolbar.It must be the same as the name attribute of the plugin
        dataCommand: '',//callbackMedia
        buttonClass:false,// The class name of the button to add, If you want to enable it even in code view mode, add a "code-view-enabled"
        title:'<?= L_MENU_MEDIAS_TITLE ?>',// HTML title attribute L_MEDIAS_TITLE
        dataDisplay:'',// 'submenu' or 'dialog' or '' (command button)
        // HTML to be append to button
        innerHTML:'<a id="file-manager-btn'+i+'" data-editorid="'+i+'" class="btn btn-block sun-editor-id-file-manager-btn" href="javascript:void(0);">➕</a>'
       }
      ],

      ['preview', 'print'],
      ['codeView', 'showBlocks']
     ],
/*
     buttonList : [[
      'save', 'font', 'fontSize', 'formatBlock',
      'bold', 'underline', 'italic', 'strike', 'subscript', 'superscript',
      'removeFormat',
      'fontColor', 'hiliteColor',﻿
      'outdent', 'indent',
      'align', 'horizontalRule', 'list', 'table',
      'link', 'image', 'video',
      'fullScreen', 'showBlocks', 'codeView',
      'preview', 'print']
     ],
     fontSize : [
      8, 10, 14, 18, 24, 36
     ],
     font : [
      'Arial',
      'tohoma',
      'Courier New,Courier'
     ],
*/

     callBackSave: function (contents) {//Fix : on save normal event call (button)
//     console.log('save callBack');
      var save_forms = document.getElementsByName("update");// article
      if(!save_forms[0])
       save_forms = document.getElementsByName("draft");// article
      if(!save_forms[0]){
       var inputs = document.getElementsByTagName('input');// other
      for (var i = 0; i < inputs.length; i++) {
       if (inputs[i].getAttribute('type') == 'submit') {
        inputs[i].click();
        return;
       }
      }
     }
     save_forms[0].click();
    },//callBackSave
   });//editor[i]

   window.document
    .getElementById('file-manager-btn'+i).parentNode
    .addEventListener('click', function(){
     fromEditor = true;
     editorid = this.children[0].getAttribute('data-editorid');
     mediasManager.openPopup(null, true);
    }
   , false);

   editor[i].onChange = function (contents) {
    is_modified = true;
    this.save();
   }
   // Called when the image is upload failed.
   // If you return false, the default notices are not called.
   editor[i].onImageUploadError = function (errorMessage, result) {
    alert(errorMessage);
   }

    let tog = document.createElement('a');
    tog.setAttribute('data-i',i);
    tog.setAttribute('data-on','on');
    tog.style='position:absolute;left:50%;margin-top:-3.33rem;color:#333;font-size:xx-large;text-decoration:none;';
    tog.id = 'toggleSE-'+textareas[i].id;
    tog.href = 'javascript:;';
    tog.title = '<?= L_YES ?> / <?= L_NO ?> SunEditor';
    tog.textContent = '☯';

    let gle = document.getElementById(textareas[i].id);// xahlee.info/js/js_insert_after.html

    gle.parentNode.insertBefore(tog, gle);// add after existing node (textareas)

    tog.addEventListener('click', function(e){
     let i = e.target.getAttribute('data-i');
     let se=editor[i];
     let on=e.target.getAttribute('data-on');
     let namt = 'plxtoolbar_' + textareas[i].name;
     let plxToolBar = document.getElementById(namt);

     //~ if(se.isDisabled)//2.31
     if(on == 'off'){
      //~ se.enabled();
      e.target.style.color='#333';
      // Change the contents of the suneditor
      editor[i].setContents(textareas[i].value);
      textareas[i].style.display='none';
      // Show the suneditor
      se.show();
      //~ editor[i] = SUNEDITOR.create(context[i]);

      if(plxToolBar){
       plxToolBar.style.display='none';
      }

     }else{
      //se.disabled();
      e.target.style.color='';
      // Copies the contents of the suneditor into a [textarea]
      se.save();
      // Hide the suneditor
      se.hide();
      // Gets the suneditor's context object. Contains settings, plugins, and cached element objects
      //context[i] = se.getContext();
      // Destroy the suneditor
      //se.destroy();
      textareas[i].style.display='';
      if(plxToolBar)plxToolBar.style.display='block';
     }
     e.target.setAttribute('data-on', on=='on'?'off':'on');
   });

  }//fi n content || chapo
 }//rof txtarea
 //Fix : on save normal event call (button)
 var inputs = document.getElementsByTagName('input');//
 for (var j = 0; j < inputs.length; j++) {
  if (inputs[j].getAttribute('type') == 'submit') {
   if (inputs[j].name != 'delete' && inputs[j].name != 'preview'){
    inputs[j].onclick = function (ev){
     editor.forEach(function(e) {
      //fix if in code mode but && if hide == return to old (editor) html code
      if(e.core.context.element.code.style.display != 'none' && e.core.context.element.topArea.style.display != 'none')
       e.core.toggleCodeView();
     });
     this.form.target = '_self';
     is_modified = 0;
     return true;
    }
   }
  }
 }
 if(window.onbeforeunload != null){var obu = window.onbeforeunload;}//onbeforeunload chained
 window.onbeforeunload = function (ev){
  if (is_modified)
   return "Your change has not been sent or saved, and will be lost if you leave this page.";
  if(obu!=null){obu();}//chained onbeforeunload
 }
}//fi typeof
</script>';

<?php  //mediaManager
  if(!file_exists(PLX_ROOT.'/core/lib/mediasManager.js'))://FROM PLX 5.5
?>
<script type="text/javascript">
 mediasManager.construct({
  windowName : "<?= L_MEDIAS_TITLE.'_'.__CLASS__ ?>",
  racine: "<?= plxUtils::getRacine() ?>",
  urlManager: "core/admin/medias.php"
 });
</script>';
<?php endif;
 }#AdminFootEndBody
 public function AdminMediasFoot(){#changement des onclic target blank en lien retour de SunEditor du gestionnaire des médias (popup)
#Fix TypeError: window.opener is null with media manager with gutuma & tinyMCE ?>
<script type="text/javascript">
if ((window.name == '<?= L_MEDIAS_TITLE.'_'.__CLASS__ ?>') || (window.opener && window.opener.fromEditor && window.opener.SUNEDITOR)){//if is media manager popup
 var tbody = document.getElementsByTagName('tbody');
 var ancres = tbody[0].getElementsByTagName('a');
 for (var i = 0; i < ancres.length; i++){
  //if(ancres[i].getAttribute('onclick') ){
  if(ancres[i].getAttribute('target') == '_blank'){//fix new system 5.9.0
   var str = ancres[i].getAttribute('onclick');
   if(str)
    var res = str.substr(0, 4);// this OR over[lay] #old plx
   else
    var res = 'this';//ancres[i].className == 'imglink'? 'this': '';//fix new system 5.9

  if(res == 'this'){
    var type = 'document';
    if ((/\.(gif|jpg|jpeg|png)$/i).test(ancres[i].href))//todo : svg
     type = 'image';
    if (/\.(tb)\./i.test(ancres[i].href))
     type = 'thumb';
    if (/\.(mp3|ogg|wav)/i.test(ancres[i].href))
     type = 'audio';
    if (/\.(mp4|ogv|webm)/i.test(ancres[i].href))
     type = 'video';

    var weight = ancres[i].parentNode.parentNode.children[4].lastChild.textContent;
    if(type == 'thumb'){
     var weight = ancres[i].parentNode.parentNode.children[4].lastChild.textContent;
     var size = ancres[i].parentNode.parentNode.children[5].lastChild.textContent;
    }else{
     var weight = ancres[i].parentNode.parentNode.children[4].firstChild.textContent;
     var size = ancres[i].parentNode.parentNode.children[5].firstChild.textContent;
    }
//idea add link with iframe mode if audio/video type OR call confirm(type + ' mode. if cancel : insert iframe') in insertMedia
    ancres[i].setAttribute('onclick','window.opener.editor[window.opener.editorid].insertHTML( insertMedia(window.opener.editorid, this.href, "'+ancres[i].title+'", "'+type+'", "'+size+'"));window.opener.fromEditor=false;window.close();return false;');//ok only at end
    ancres[i].style.color="green";
    ancres[i].title = "Ajouter "+ancres[i].title+" a l'article ("+type+").";
   }
  }
 }

 /**
  *  Méthode d'insertion d'une ressource.
  *  TODO? Enrichir cette méthode.
  *  @param {String} id Identifiant de la zone éditée.
  *  @param {String} url Url de la ressource.
  *  @param {String} name Nom de la ressource (alt image).
  *  @param {String} type Type de la ressource (document,image,thumb,audio,video).
  */
 function insertMedia(id, url, name, type, size) {
  //~ console.log('insertMedia', id, window.opener.editor[id], url, name, type, size);
  var sunType = (type == 'image' || type == 'thumb') ? 'image' : ((type != 'audio' && type != 'video')? 'iframe': type);//type !iframe-container is old! :::: audio : with video #maybe all other type
  var sunSize = size.replace(' x ',',');//console.log('sunSize',sunSize);//alert("pause");
  var sunSizes = sunSize.split(',');//console.log('sunSize',sunSize);//alert("pause");
  var figStyle = sunType=='image'? 'margin: 0px;': 'width: 100%; height: 56.25%; padding-bottom: 56.25%; margin: 0px;';
  var htmla = ['<div class="se-component se-'+sunType+'-container __se__float-none plx-'+type+'" contenteditable="false">', '<figure style="'+figStyle+'">'];//
  var htmlz = ['</div>', '</figure>'];//<p><br></p>
  //~ var attrs = 'data-align="none" data-rotate="" data-proportion="true" data-rotatex="" data-rotatey="" style="max-width: 100%; width: '+sunSizes[0]+'px; transform: rotate(0deg);"';// data-
  var attrs = 'data-rotate="" data-proportion="true" data-rotatex="" data-rotatey="" style="" data-size="," data-align="none" data-percentage="auto,auto" data-file-name="'+name+'"';// data-index="0" data-file-size="25007" origin-size="1000,1000" data-origin=","';// data-

  if (sunType === 'image') {//+ type thumb
   html = htmla[1] + '<img src="' + url + '" alt="' + name + '" title="' + name + '" origin-size="' + sunSize + '" data-origin="' + sunSize + '" '+attrs+'>' + htmlz[1];// origin-size="100,100" data-origin="102,102"
  //~ } else if (type === 'video' || type === 'audio') {
   //~ html = htmla[1] + '<'+type+' controls="1" allowfullscreen="1" src="' + url + '" title="' + name + '" '+attrs+'><a href="' + url + '">' + name + '</a></'+type+'>' + htmlz[1];//<i><p>' + name + '</p>
  } else {//other
   html = htmla[1] + '<iframe src="' + url + '" class="full-width" allowfullscreen="" data-proportion="true" style="width: 100%; height: 100%;" data-percentage="100%,56.25%" data-size="100%,56.25%" data-align="none" data-origin="100%,56.25%" frameborder="0"></iframe>' + htmlz[1];//</i><p>' + name + '</p>
  }
  return htmla[0] + html + htmlz[0];// + '<p>' + name + '</p>';
 }
}
</script>
<?php
 }#AdminMediasFoot
}
